﻿''' <summary>
''' １秒間に６０フレーム分表示されるよう制御を行うクラス
''' </summary>
''' <remarks></remarks>
Public Class clsFPS
    Private Const FPS As Integer = 60 '１秒間に表示されるフレーム数

    Private nowTime As Integer '現在の処理時間
    Private lastTime As Integer '前回の処理時間
    Private progress As Integer '経過時間
    Private ideal As Integer '理想時間
    Private frame As Integer '現在のフレーム数
    Private maxFrame As Integer 'フレーム数制限値

    Public Sub startFpsLimit(ByVal maxFrame As Integer)
        Me.maxFrame = maxFrame
        nowTime = Environment.TickCount
        If lastTime = 0 Then
            lastTime = nowTime
        End If
        progress = nowTime - lastTime
        ideal = CInt((frame * (1000.0F / FPS)))
    End Sub

    Public Function endFpsLimit(ByVal alphaAmount As Integer)
        If alphaAmount = maxFrame Then
            Return alphaAmount
        End If
        Dim newFrame As Integer = frame
        If (ideal > progress) Then
            System.Threading.Thread.Sleep(ideal - progress)
        End If

        If (ideal < progress) Then
            'フレームスキップ量を算出
            newFrame = alphaAmount + Math.Ceiling(((progress - ideal) / CInt((1 * (1000.0F / FPS)))))
            If newFrame >= maxFrame Then
                newFrame = maxFrame - 1
            End If
            alphaAmount = newFrame
        End If
        frame = newFrame + 1
        Return alphaAmount
    End Function
End Class
