﻿Public Class clsNumberObject
    Private x As Integer
    Private y As Integer
    Private side As Integer
    Private bingoString As String
    Private numberString As String

    Private color As Color
    Private color2 As Color

    Private alpha As Integer
    Private _enabled As Boolean

    Private stringColor As SolidBrush

    Public Sub New(ByVal x As Integer,
                   ByVal y As Integer,
                   ByVal side As Integer,
                   ByVal number As Integer,
                   ByVal alpha As Integer,
                   ByVal enabled As Boolean)
        Me.x = x
        Me.y = y
        Me.side = side
        Me.numberString = CStr(number)
        Me.alpha = alpha
        Me._enabled = enabled
        setBingoString()
        setObjectColor()
        setStringColor()
    End Sub

    Public Function getNumberPicture() As System.Drawing.Bitmap
        Dim bitmap As New Bitmap(Me.x + Me.side, Me.y + Me.side)
        Dim graphics As Graphics = graphics.FromImage(bitmap)

        '円描画
        Dim c As New Drawing2D.LinearGradientBrush(New Point(Me.x, Me.y),
                                                   New Point(Me.x + Me.side, Me.y + Me.side),
                                                   color.FromArgb(alpha * (255 / 100), Me.color),
                                                   color.FromArgb(alpha * (255 / 100), Me.color2))
        graphics.FillEllipse(c,
                             Me.x,
                             Me.y,
                             Me.side,
                             Me.side)

        '文字描画
        Dim fontFamilyName As String = "Plantagenet Cherokee"
        Dim sf As New StringFormat
        sf.Alignment = StringAlignment.Center
        sf.LineAlignment = StringAlignment.Center
        graphics.SmoothingMode = Drawing2D.SmoothingMode.AntiAlias
        graphics.TextRenderingHint = System.Drawing.Text.TextRenderingHint.AntiAlias
        graphics.DrawString(Me.bingoString,
                            New Font(fontFamilyName, CInt(Me.side * 0.2), FontStyle.Bold),
                            stringColor,
                            Me.x + Me.side / 2,
                            Me.y + Me.side / 5.5,
                            sf)
        graphics.DrawString(Me.numberString,
                            New Font(fontFamilyName, CInt(Me.side * 0.5), FontStyle.Bold),
                            stringColor,
                            Me.x + Me.side / 2,
                            Me.y + Me.side / 1.7,
                            sf)
        graphics.Dispose()

        Return bitmap
    End Function

#Region "プライベートメソッド"
    Private Sub setBingoString()
        If Not Me._enabled Then
            Me.bingoString = " "
            Exit Sub
        End If
        Select Case CInt(Me.numberString)
            Case 1 To 15
                Me.bingoString = "B"
            Case 16 To 30
                Me.bingoString = "I"
            Case 31 To 45
                Me.bingoString = "N"
            Case 46 To 60
                Me.bingoString = "G"
            Case 61 To 75
                Me.bingoString = "O"
            Case Else
                Me.bingoString = " "
        End Select
    End Sub

    Private Sub setObjectColor()
        If Not Me._enabled Then
            Me.color2 = color.FromArgb(alpha, color.FromArgb(224, 218, 228))
            Me.color = getThinColor(color2)
            Exit Sub
        End If
        Select Case Me.bingoString
            Case "B"
                Me.color2 = color.FromArgb(alpha, 255, 0, 153) 'ピンク
            Case "I"
                Me.color2 = color.FromArgb(alpha, 255, 51, 25) '柿色
            Case "N"
                Me.color2 = color.FromArgb(alpha, 255, 153, 0) 'オレンジ
            Case "G"
                Me.color2 = color.FromArgb(alpha, 102, 204, 0) '黄緑
            Case "O"
                Me.color2 = color.FromArgb(alpha, 0, 204, 255) '水色
            Case Else
                Me.color2 = color.FromArgb(alpha, color.Black) '黒色
        End Select
        Me.color = getThinColor(color2)
    End Sub

    Private Sub setStringColor()
        Dim color As Color
        If Me._enabled Then
            color = color.Black
        Else
            color = color.DimGray
        End If
        Me.stringColor = New SolidBrush(color.FromArgb(alpha * (255 / 100), color))
    End Sub

    Private Function getThinColor(ByVal fromColor As Color) As Color
        Dim oldColor As Integer = fromColor.ToArgb
        Dim r As Integer = (oldColor And &HFF0000) >> 16
        Dim g As Integer = (oldColor And &HFF00) >> 8
        Dim b As Integer = oldColor And &HFF

        Dim addValue As Integer = 150
        r = If((r + addValue) > &HFF, &HFF, r + addValue)
        g = If((g + addValue) > &HFF, &HFF, g + addValue)
        b = If((b + addValue) > &HFF, &HFF, b + addValue)

        Return color.FromArgb(r, g, b)
    End Function
#End Region
End Class
