﻿''' <summary>
''' オブジェクトパラメータークラス
''' </summary>
''' <remarks></remarks>
Public Class clsObjectParameter
    Private formNewHeight As Integer
    Private formNewWidth As Integer
    Public Const formOldHeight As Integer = 511
    Public Const formOldWidth As Integer = 930

    Private xRatio As Single
    Private yRatio As Single
    Public minRatio As Single

    Public Const maxAlpha As Integer = 100 '濃度

    Public initialPictureSize As Integer
    Public initialPicturePosition As Point

    Public centerPictureSize As Integer
    Public centerPicturePosition As Point
    Public distanceInitialToCenter As Integer

    Public fixedPictureSize As Integer
    Public fixedPicturePosition As Point
    Public distanceCenterToFixed As Integer

    Public historyObjectSize As Integer
    Public historyStartPosition As Point

    Public gameInformationStringObjectPosition As Point

    Private interval As Integer
    Private Const rowCount As Integer = 15

    Public Sub New(ByVal height As Integer,
                   ByVal width As Integer)
        formNewHeight = height
        formNewWidth = width

        xRatio = formNewWidth / formOldWidth
        yRatio = formNewHeight / formOldHeight
        minRatio = Math.Min(xRatio, yRatio)

        init()
    End Sub

    Private Sub init()
        initialPictureSize = 150 * minRatio '初期サイズ
        initialPicturePosition = New Point(60 * minRatio, 310 * minRatio) '初期表示位置

        centerPictureSize = 470 * minRatio '中央サイズ（最大サイズ）
        centerPicturePosition = New Point(((930 - 470) / 2) * minRatio, 20 * minRatio) '中央位置
        distanceInitialToCenter = Math.Sqrt(Math.Pow(centerPicturePosition.X - initialPicturePosition.X, 2) +
                                            Math.Pow(centerPicturePosition.Y - initialPicturePosition.Y, 2)) '初期位置と中央位置の距離

        fixedPictureSize = 50 * minRatio '所定サイズ（最小サイズ）
        fixedPicturePosition = New Point(20 * minRatio, 20 * minRatio) '所定開始位置
        distanceCenterToFixed = Math.Sqrt(Math.Pow(fixedPicturePosition.X - centerPicturePosition.X, 2) +
                                          Math.Pow(fixedPicturePosition.Y - centerPicturePosition.Y, 2)) '初期位置と中央位置の距離

        historyObjectSize = 35 * minRatio '履歴サイズ
        historyStartPosition = New Point(250 * minRatio, 310 * minRatio)

        interval = 55 * minRatio
    End Sub

    Public Sub calcObjectGameInfoStringParameter()
        init()
        gameInformationStringObjectPosition = initialPicturePosition
        gameInformationStringObjectPosition.Offset(initialPictureSize / 2, initialPictureSize + (10 * minRatio))
    End Sub

    Public Sub calcObjectNumberStringParameter(ByVal numberString As Integer)
        init()
        Dim column As Integer = numberString Mod rowCount
        Dim row As Integer = numberString \ rowCount

        Me.fixedPicturePosition.X = Me.fixedPicturePosition.X + IIf(column = 0, interval * rowCount, column * interval)
        Me.fixedPicturePosition.Y = Me.fixedPicturePosition.Y + IIf(column = 0, (row - 1) * interval, row * interval)

        Me.distanceCenterToFixed = Math.Sqrt(Math.Pow(fixedPicturePosition.X - centerPicturePosition.X, 2) + _
                                             Math.Pow(fixedPicturePosition.Y - centerPicturePosition.Y, 2))
    End Sub

    Public Sub calcObjectStringParameter(ByVal objectString As String)
        init()
        Select Case objectString
            Case "B"
                Me.fixedPicturePosition.Y = fixedPicturePosition.Y + (interval * 0)
            Case "I"
                Me.fixedPicturePosition.Y = fixedPicturePosition.Y + (interval * 1)
            Case "N"
                Me.fixedPicturePosition.Y = fixedPicturePosition.Y + (interval * 2)
            Case "G"
                Me.fixedPicturePosition.Y = fixedPicturePosition.Y + (interval * 3)
            Case "O"
                Me.fixedPicturePosition.Y = fixedPicturePosition.Y + (interval * 4)
        End Select
        Me.distanceCenterToFixed = Math.Sqrt(Math.Pow(fixedPicturePosition.X - centerPicturePosition.X, 2) + _
                                             Math.Pow(fixedPicturePosition.Y - centerPicturePosition.Y, 2))
    End Sub
End Class
