﻿Public Class clsStringObject
    Private x As Integer
    Private y As Integer
    Private side As Integer
    Private objectString As String
    Private objectBackColor As Color = Color.Transparent
    Private stringColor As SolidBrush = New SolidBrush(Color.Black)

    Public Sub New(ByVal x As Integer,
                   ByVal y As Integer,
                   ByVal side As Integer,
                   ByVal objectString As String)
        Me.x = x
        Me.y = y
        Me.side = side
        Me.objectString = objectString
    End Sub

    Public Function getStringObject() As System.Drawing.Bitmap
        Dim bitmap As New Bitmap(Me.x + Me.side, Me.y + Me.side)
        Dim graphics As Graphics = graphics.FromImage(bitmap)

        '円描画
        Dim circle As New Drawing2D.LinearGradientBrush(New Point(Me.x, Me.y),
                                                        New Point(Me.x + Me.side, Me.y + Me.side),
                                                        objectBackColor,
                                                        objectBackColor)
        graphics.FillEllipse(circle,
                             Me.x,
                             Me.y,
                             Me.side,
                             Me.side)

        '文字描画
        Dim fontFamilyName As String = "HG創英角ﾎﾟｯﾌﾟ体"
        Dim sf As New StringFormat
        sf.Alignment = StringAlignment.Center
        sf.LineAlignment = StringAlignment.Center
        graphics.SmoothingMode = Drawing2D.SmoothingMode.AntiAlias
        graphics.TextRenderingHint = System.Drawing.Text.TextRenderingHint.AntiAlias
        graphics.DrawString(StrConv(Me.objectString, VbStrConv.Wide),
                            New Font(fontFamilyName, CInt(Me.side * 0.5), FontStyle.Bold),
                            stringColor,
                            Me.x + Me.side / 2,
                            Me.y + Me.side / 1.7,
                            sf)
        graphics.Dispose()

        Return bitmap
    End Function
End Class
