﻿Public Class frmBingo
    '定数
    Private Const minNumber As Integer = 1
    Private Const maxNumber As Integer = 75
    Private Const maxHistoryCount As Integer = 5

    'グラフィック定義
    Private backgroundGraphics As Graphics
    Private foregroundGraphics As Graphics
    Private backgroundBitmap As Bitmap
    Private backgroundBitmapLast As Bitmap

    'リスト定義
    Private numberList As New clsRandomNumber(frmBingo.maxNumber)
    Private historyList As New clsNumberList(frmBingo.maxHistoryCount)

    '色定義
    Private objBackColor As Color = Color.Gold
    Private objBackBrush As Brush = Brushes.Gold
    Private objNumberFieldBackBruch As Brush = Brushes.DodgerBlue
    Private objInitialNumberFieldBackBruch As Brush = Brushes.White

    '座標
    Private objectParameter As clsObjectParameter

    'ステータス
    Private stateShowNumberObject As Boolean

    'ログ
    Private cBingoLog As New clsLog

#Region "イベント"
    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        Me.formInit()
        Me.Refresh()
        Me.graphicsInit()

        Me.drawInitialNumberObject()
        Me.drawStringBingoObject()
        Me.drawNumberBackFieldObject()
        Me.drawNumberFieldObject()
        Me.drawStringFieldObject()

        Me.readBingoLog()

        Me.PictureBox1.Refresh()
    End Sub

    Private Sub PictureBox1_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles PictureBox1.Paint
        If Not IsNothing(Me.backgroundBitmap) Then
            e.Graphics.DrawImage(Me.backgroundBitmap, 0, 0)
        End If
    End Sub

    Private Sub btnPlay_Click(sender As System.Object, e As System.EventArgs) Handles btnPlay.Click
        Try
            btnPlay.Enabled = False
            If Not stateShowNumberObject Then
                Dim number As Integer = numberList.getRandomNumber()
                Me.cBingoLog.writeLog(number)
                Me.drawGameInformation()
                Me.drawNumberAndHistoryObject(number)
            Else
                Me.drawNumberAndHistoryObject2(numberList.nowNumber)
            End If
        Finally
            btnPlay.Enabled = True
            btnPlay.Focus()
        End Try
    End Sub

    Private Sub btnNumberButton_Click(sender As System.Object, e As System.EventArgs) Handles btnNumber01.Click,
                                                                                              btnNumber02.Click,
                                                                                              btnNumber15.Click,
                                                                                              btnNumber16.Click,
                                                                                              btnNumber30.Click,
                                                                                              btnNumber31.Click,
                                                                                              btnNumber45.Click,
                                                                                              btnNumber46.Click,
                                                                                              btnNumber60.Click,
                                                                                              btnNumber61.Click,
                                                                                              btnNumber75.Click
        If Not stateShowNumberObject Then
            Dim numberString As String = sender.text
            Me.numberList.deleteNumber(numberString)
            Me.drawGameInformation()
            Me.drawNumberAndHistoryObject(numberString)
        Else
            Me.drawNumberAndHistoryObject2(numberList.nowNumber)
        End If

    End Sub

    Private Sub btnExit_Click(sender As System.Object, e As System.EventArgs) Handles btnExit.Click
        If MessageBox.Show(Me,
                           "ビンゴを終了します。よろしいですか？",
                           "ビンゴ",
                           MessageBoxButtons.OKCancel,
                           MessageBoxIcon.Question,
                           MessageBoxDefaultButton.Button2) = Windows.Forms.DialogResult.OK Then
            Me.Close()
        End If
    End Sub

#End Region

#Region "プライベートメソッド"
    ''' <summary>
    ''' 数値の描画と履歴の描画
    ''' </summary>
    ''' <param name="number"></param>
    ''' <remarks></remarks>
    Private Sub drawNumberAndHistoryObject(ByVal number As Integer)
        Me.objectParameter.calcObjectNumberStringParameter(number)
        Dim interval As Integer = 7 * Me.objectParameter.minRatio

        '履歴リストに数値追加
        historyList.add(number)

        '履歴クリア
        Me.backgroundGraphics.FillRectangle(Me.objBackBrush,
                                            Me.objectParameter.historyStartPosition.X,
                                            Me.objectParameter.historyStartPosition.Y,
                                            (Me.objectParameter.historyObjectSize + interval) * (maxHistoryCount - 1),
                                            Me.objectParameter.historyObjectSize)
        Me.copyBitmapLast()

        'ループ①
        '・徐々に表示する
        Dim maxSpeedMode1 As Integer = 60
        Dim fps1 As New clsFPS
        Dim startTime As Integer = Environment.TickCount
        For alphaAmount As Integer = 1 To maxSpeedMode1
            fps1.startFpsLimit(maxSpeedMode1)
            backgroundGraphics.Clear(objBackColor)
            Using picture As Image = New clsNumberObject(Me.objectParameter.initialPicturePosition.X, _
                                                         Me.objectParameter.initialPicturePosition.Y, _
                                                         Me.objectParameter.initialPictureSize, _
                                                         number, _
                                                         alphaAmount * (clsObjectParameter.maxAlpha / maxSpeedMode1), _
                                                         True).getNumberPicture
                Me.backgroundGraphics.DrawImage(Me.backgroundBitmapLast, 0, 0, Me.PictureBox1.Width, Me.PictureBox1.Height)
                Me.backgroundGraphics.DrawImage(picture, New Rectangle(New Point, picture.Size), 0, 0, picture.Width, picture.Height, GraphicsUnit.Pixel)
            End Using

            '履歴表示
            For j As Integer = historyList.count To 1 Step -1
                '移動量
                Dim diff As Integer
                If j = 1 Then
                    diff = 0
                Else
                    diff = alphaAmount * ((Me.objectParameter.historyObjectSize + interval) / maxSpeedMode1)
                End If

                '表示位置
                Dim position As Integer
                If j = 1 Or j = 2 Then
                    position = 0
                Else
                    position = (j - 2) * (Me.objectParameter.historyObjectSize + interval)
                End If

                '濃度
                Dim alpha As Integer
                If j = 1 Then
                    alpha = alphaAmount * (clsObjectParameter.maxAlpha / maxSpeedMode1)
                Else
                    alpha = 100
                End If

                Using picture As Image = New clsNumberObject(Me.objectParameter.historyStartPosition.X + position + diff, _
                                                             Me.objectParameter.historyStartPosition.Y, _
                                                             Me.objectParameter.historyObjectSize, _
                                                             historyList.value(j - 1), _
                                                             alpha, _
                                                             True).getNumberPicture
                    backgroundGraphics.DrawImage(picture, New Rectangle(New Point, picture.Size), 0, 0, picture.Width, picture.Height, GraphicsUnit.Pixel)
                End Using
            Next
            Me.PictureBox1.Refresh()
            alphaAmount = fps1.endFpsLimit(alphaAmount)
        Next
        Me.copyBitmapLast()

        '番号表示フィールドをクリアする。
        Dim space As Integer = 5 * Me.objectParameter.minRatio
        Me.backgroundGraphics.DrawImage(Me.backgroundBitmapLast, 0, 0, Me.PictureBox1.Width, Me.PictureBox1.Height)
        Dim size As New Size(Me.objectParameter.initialPictureSize / 10, Me.objectParameter.initialPictureSize / 10)
        Dim rect As New Rectangle(Me.objectParameter.initialPicturePosition.X - space, _
                                  Me.objectParameter.initialPicturePosition.Y - space, _
                                  Me.objectParameter.initialPictureSize + (space * 2), _
                                  Me.objectParameter.initialPictureSize + (space * 2))
        Me.FillRoundedRectangle(Me.backgroundGraphics, Me.objInitialNumberFieldBackBruch, rect, size)
        Me.copyBitmapLast()

        'ループ②
        '・画面中央に移動しながら拡大
        Dim fps2 As New clsFPS
        Dim maxSpeedMode2 As Integer = 60
        For movementAmount As Integer = 1 To maxSpeedMode2
            fps2.startFpsLimit(maxSpeedMode2)
            backgroundGraphics.Clear(objBackColor)
            Using picture As Image = New clsNumberObject(Me.objectParameter.initialPicturePosition.X + ((movementAmount * (Me.objectParameter.distanceInitialToCenter / maxSpeedMode2) * (Me.objectParameter.centerPicturePosition.X - Me.objectParameter.initialPicturePosition.X)) / Me.objectParameter.distanceInitialToCenter),
                                                         Me.objectParameter.initialPicturePosition.Y + ((movementAmount * (Me.objectParameter.distanceInitialToCenter / maxSpeedMode2) * (Me.objectParameter.centerPicturePosition.Y - Me.objectParameter.initialPicturePosition.Y)) / Me.objectParameter.distanceInitialToCenter),
                                                         Me.objectParameter.initialPictureSize + ((movementAmount * (Me.objectParameter.distanceInitialToCenter / maxSpeedMode2) * (Me.objectParameter.centerPictureSize - Me.objectParameter.initialPictureSize)) / Me.objectParameter.distanceInitialToCenter),
                                                         number,
                                                         clsObjectParameter.maxAlpha,
                                                         True).getNumberPicture
                backgroundGraphics.DrawImage(Me.backgroundBitmapLast, 0, 0, Me.PictureBox1.Width, Me.PictureBox1.Height)
                backgroundGraphics.DrawImage(picture, New Rectangle(New Point, picture.Size), 0, 0, picture.Width, picture.Height, GraphicsUnit.Pixel)
                Me.PictureBox1.Refresh()
            End Using
            movementAmount = fps2.endFpsLimit(movementAmount)
        Next

        Me.stateShowNumberObject = True
    End Sub

    Private Sub drawNumberAndHistoryObject2(ByVal number As Integer)
        'ループ③
        '・所定位置に移動しながら縮小
        Dim maxSpeedMode3 As Integer = 60
        Dim fps3 As New clsFPS
        For movementAmount As Integer = 1 To maxSpeedMode3
            fps3.startFpsLimit(maxSpeedMode3)
            backgroundGraphics.Clear(objBackColor)
            Using picture As Image = New clsNumberObject(Me.objectParameter.centerPicturePosition.X + ((movementAmount * (Me.objectParameter.distanceCenterToFixed / maxSpeedMode3) * (Me.objectParameter.fixedPicturePosition.X - Me.objectParameter.centerPicturePosition.X)) / Me.objectParameter.distanceCenterToFixed),
                                                         Me.objectParameter.centerPicturePosition.Y + ((movementAmount * (Me.objectParameter.distanceCenterToFixed / maxSpeedMode3) * (Me.objectParameter.fixedPicturePosition.Y - Me.objectParameter.centerPicturePosition.Y)) / Me.objectParameter.distanceCenterToFixed),
                                                         Me.objectParameter.centerPictureSize + ((movementAmount * (Me.objectParameter.distanceCenterToFixed / maxSpeedMode3) * (Me.objectParameter.fixedPictureSize - Me.objectParameter.centerPictureSize)) / Me.objectParameter.distanceCenterToFixed),
                                                         number,
                                                         clsObjectParameter.maxAlpha,
                                                         True).getNumberPicture
                backgroundGraphics.DrawImage(Me.backgroundBitmapLast, 0, 0, Me.PictureBox1.Width, Me.PictureBox1.Height)
                backgroundGraphics.DrawImage(picture, New Rectangle(New Point, picture.Size), 0, 0, picture.Width, picture.Height, GraphicsUnit.Pixel)
                Me.PictureBox1.Refresh()
            End Using
            movementAmount = fps3.endFpsLimit(movementAmount)
        Next

        '最終系を保持する。
        Me.copyBitmapLast()

        Me.stateShowNumberObject = False
    End Sub

    Private Sub drawNumberAndHistoryObject3(ByVal number As Integer)
        'ループ③
        '・所定位置に移動しながら縮小
        Dim maxSpeedMode3 As Integer = 1
        For movementAmount As Integer = 1 To maxSpeedMode3
            backgroundGraphics.Clear(objBackColor)
            Using picture As Image = New clsNumberObject(Me.objectParameter.centerPicturePosition.X + ((movementAmount * (Me.objectParameter.distanceCenterToFixed / maxSpeedMode3) * (Me.objectParameter.fixedPicturePosition.X - Me.objectParameter.centerPicturePosition.X)) / Me.objectParameter.distanceCenterToFixed),
                                                         Me.objectParameter.centerPicturePosition.Y + ((movementAmount * (Me.objectParameter.distanceCenterToFixed / maxSpeedMode3) * (Me.objectParameter.fixedPicturePosition.Y - Me.objectParameter.centerPicturePosition.Y)) / Me.objectParameter.distanceCenterToFixed),
                                                         Me.objectParameter.centerPictureSize + ((movementAmount * (Me.objectParameter.distanceCenterToFixed / maxSpeedMode3) * (Me.objectParameter.fixedPictureSize - Me.objectParameter.centerPictureSize)) / Me.objectParameter.distanceCenterToFixed),
                                                         number,
                                                         clsObjectParameter.maxAlpha,
                                                         True).getNumberPicture
                backgroundGraphics.DrawImage(Me.backgroundBitmapLast, 0, 0, Me.PictureBox1.Width, Me.PictureBox1.Height)
                backgroundGraphics.DrawImage(picture, New Rectangle(New Point, picture.Size), 0, 0, picture.Width, picture.Height, GraphicsUnit.Pixel)
            End Using
        Next
        '最終系を保持する
        Me.copyBitmapLast()

        Me.stateShowNumberObject = False
    End Sub

    ''' <summary>
    ''' BINGO文字を描画する
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub drawStringBingoObject()
        backgroundGraphics.Clear(objBackColor)
        Dim bingoStringList As String() = {"B", "I", "N", "G", "O"}

        For Each bingoString As String In bingoStringList
            Me.objectParameter.calcObjectStringParameter(bingoString)
            Using picture As Image = New clsStringObject(Me.objectParameter.fixedPicturePosition.X,
                                                         Me.objectParameter.fixedPicturePosition.Y,
                                                         Me.objectParameter.fixedPictureSize,
                                                         bingoString).getStringObject
                backgroundGraphics.DrawImage(Me.backgroundBitmapLast, 0, 0, Me.PictureBox1.Width, Me.PictureBox1.Height)
                backgroundGraphics.DrawImage(picture, New Rectangle(New Point, picture.Size), 0, 0, picture.Width, picture.Height, GraphicsUnit.Pixel)
            End Using
            Me.copyBitmapLast()
        Next
    End Sub

    ''' <summary>
    ''' 角が丸い四角のオブジェクトを作成する
    ''' </summary>
    ''' <param name="g"></param>
    ''' <param name="backBrush"></param>
    ''' <param name="rect"></param>
    ''' <param name="size"></param>
    ''' <remarks></remarks>
    Private Sub FillRoundedRectangle(ByVal g As Graphics, _
                                     ByVal backBrush As Brush, _
                                     ByVal rect As Rectangle, _
                                     ByVal size As Size)
        Dim sm As System.Drawing.Drawing2D.SmoothingMode
        Dim pom As System.Drawing.Drawing2D.PixelOffsetMode
        Dim graphicPath As System.Drawing.Drawing2D.GraphicsPath

        sm = g.SmoothingMode
        pom = g.PixelOffsetMode
        g.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.AntiAlias
        g.PixelOffsetMode = System.Drawing.Drawing2D.PixelOffsetMode.HighQuality

        graphicPath = New System.Drawing.Drawing2D.GraphicsPath
        graphicPath.FillMode = System.Drawing.Drawing2D.FillMode.Winding
        graphicPath.AddArc(rect.Right - size.Width, rect.Top, size.Width, size.Height, 270, 90)
        graphicPath.AddArc(rect.Right - size.Width, rect.Bottom - size.Height, size.Width, size.Height, 0, 90)
        graphicPath.AddArc(rect.Left, rect.Bottom - size.Height, size.Width, size.Height, 90, 90)
        graphicPath.AddArc(rect.Left, rect.Top, size.Width, size.Height, 180, 90)
        graphicPath.AddArc(rect.Right - size.Width, rect.Top, size.Width, size.Height, 270, 90)
        g.FillPath(backBrush, graphicPath)

        g.SmoothingMode = sm
        g.PixelOffsetMode = pom
    End Sub

    Private Sub drawGameInformation()
        Me.objectParameter.calcObjectGameInfoStringParameter()
        Dim font As String = "Plantagenet Cherokee"
        Dim fontSize As Integer = 18 * Me.objectParameter.minRatio
        Dim gameInformationString As String = "残ゲーム数 : " & numberList.nowCounter & " / " & numberList.maxNumber

        Dim sf As New StringFormat
        sf.Alignment = StringAlignment.Center

        Me.backgroundGraphics.DrawImage(Me.backgroundBitmapLast, 0, 0, Me.PictureBox1.Width, Me.PictureBox1.Height)
        Me.backgroundGraphics.FillRectangle(Me.objBackBrush, 0, Me.objectParameter.gameInformationStringObjectPosition.Y, CSng(Me.PictureBox1.Width / 2), Me.PictureBox1.Height)
        Me.backgroundGraphics.DrawString(gameInformationString, New Font(font, fontSize), Brushes.Black, Me.objectParameter.gameInformationStringObjectPosition, sf)
        Me.PictureBox1.Refresh()
        Me.copyBitmapLast()
    End Sub

    Private Sub formInit()
        Me.SetStyle(ControlStyles.ResizeRedraw, True)
        Me.DoubleBuffered = True
        Me.BackColor = objBackColor
        Me.PictureBox1.BorderStyle = BorderStyle.None
        Me.MaximizeBox = False
        Me.WindowState = FormWindowState.Maximized
        Me.FormBorderStyle = Windows.Forms.FormBorderStyle.None
        'Me.Height = 768
        'Me.Width = 1366

        If Me.FormBorderStyle = Windows.Forms.FormBorderStyle.None Then
            Me.objectParameter = New clsObjectParameter(Me.Height, Me.Width)
        Else
            'あくまでWindows7のクラシックUIの場合のみ有効な数値
            Me.objectParameter = New clsObjectParameter(Me.Height - 25, Me.Width - 6)
        End If

        Me.PictureBox1.Height = clsObjectParameter.formOldHeight * Me.objectParameter.minRatio
        Me.PictureBox1.Width = clsObjectParameter.formOldWidth * Me.objectParameter.minRatio

        'ボタン
        For Each control In Me.Controls
            'If control.GetType Is GetType(Button) Then
            'Dim button As Button = CType(control, Button)
            'button.Font = New Font(button.Font.Name, button.Font.Size * Me.objectParameter.minRatio)
            '    button.Height = (button.Height * Me.objectParameter.minRatio)
            '    button.Width = (button.Width * Me.objectParameter.minRatio)
            '    button.Left = (button.Location.X * Me.objectParameter.minRatio)
            '    button.Top = (button.Location.Y * Me.objectParameter.minRatio)
            'End If
            If control.GetType Is GetType(Button) OrElse control.GetType Is GetType(Label) Then
                control.Font = New Font(control.Font.Name.ToString, control.Font.Size * Me.objectParameter.minRatio)
                control.Height = (control.Height * Me.objectParameter.minRatio)
                control.Width = (control.Width * Me.objectParameter.minRatio)
                control.Left = (control.Location.X * Me.objectParameter.minRatio)
                control.Top = (control.Location.Y * Me.objectParameter.minRatio)
            End If
        Next
        btnExit.Width = 0
        btnExit.Height = 0

#If Not Debug Then
        Me.btnNumber01.Visible = False
        Me.btnNumber02.Visible = False
        Me.btnNumber15.Visible = False
        Me.btnNumber16.Visible = False
        Me.btnNumber30.Visible = False
        Me.btnNumber31.Visible = False
        Me.btnNumber45.Visible = False
        Me.btnNumber46.Visible = False
        Me.btnNumber60.Visible = False
        Me.btnNumber61.Visible = False
        Me.btnNumber75.Visible = False
#End If

        Me.btnPlay.Focus()
    End Sub

    Private Sub graphicsInit()
        Me.backgroundBitmap = New Bitmap(Me.PictureBox1.Width, Me.PictureBox1.Height)
        Me.backgroundBitmapLast = New Bitmap(Me.PictureBox1.Width, Me.PictureBox1.Height)
        Me.backgroundGraphics = Graphics.FromImage(backgroundBitmap)
        Me.backgroundGraphics.SmoothingMode = Drawing2D.SmoothingMode.AntiAlias
        Me.backgroundGraphics.TextRenderingHint = System.Drawing.Text.TextRenderingHint.AntiAlias
        Me.foregroundGraphics = Me.PictureBox1.CreateGraphics
        Me.foregroundGraphics.SmoothingMode = Drawing2D.SmoothingMode.AntiAlias
        Me.foregroundGraphics.TextRenderingHint = System.Drawing.Text.TextRenderingHint.AntiAlias
        Me.backgroundGraphics.Clear(objBackColor)
    End Sub

    Private Sub copyBitmapLast()
        Me.backgroundBitmapLast.Dispose()
        Me.backgroundBitmapLast = backgroundBitmap.Clone
    End Sub

    Private Sub drawInitialNumberObject()
        Dim space As Integer = 5 * Me.objectParameter.minRatio
        Dim size As New Size(Me.objectParameter.initialPictureSize / 10, Me.objectParameter.initialPictureSize / 10)
        Dim rect As New Rectangle(Me.objectParameter.initialPicturePosition.X - space,
                                  Me.objectParameter.initialPicturePosition.Y - space,
                                  Me.objectParameter.initialPictureSize + (space * 2),
                                  Me.objectParameter.initialPictureSize + (space * 2))
        Me.backgroundGraphics.DrawImage(Me.backgroundBitmapLast, 0, 0, Me.PictureBox1.Width, Me.PictureBox1.Height)
        Me.FillRoundedRectangle(Me.backgroundGraphics, Me.objInitialNumberFieldBackBruch, rect, size)
        Me.copyBitmapLast()
    End Sub

    Private Sub drawNumberBackFieldObject()
        'このあたりだめ
        Me.objectParameter.calcObjectNumberStringParameter(frmBingo.maxNumber)
        Dim maxPoint As New Point(Me.objectParameter.fixedPicturePosition)
        Me.objectParameter.calcObjectNumberStringParameter(frmBingo.minNumber)

        Dim space As Integer = 5 * Me.objectParameter.minRatio
        Dim size As New Size(Me.objectParameter.initialPictureSize / 10,
                             Me.objectParameter.initialPictureSize / 10)
        Dim rect As New Rectangle(Me.objectParameter.fixedPicturePosition.X - space,
                                  Me.objectParameter.fixedPicturePosition.Y - space,
                                  maxPoint.X - Me.objectParameter.fixedPicturePosition.X + Me.objectParameter.fixedPictureSize + (space * 2),
                                  maxPoint.Y - Me.objectParameter.fixedPicturePosition.Y + Me.objectParameter.fixedPictureSize + (space * 2))
        Me.backgroundGraphics.DrawImage(Me.backgroundBitmapLast, 0, 0, Me.PictureBox1.Width, Me.PictureBox1.Height)
        Me.FillRoundedRectangle(Me.backgroundGraphics, objNumberFieldBackBruch, rect, size)
        Me.copyBitmapLast()
    End Sub

    Private Sub drawNumberFieldObject()
        For movementAmount As Integer = frmBingo.minNumber To frmBingo.maxNumber
            Me.objectParameter.calcObjectNumberStringParameter(movementAmount)
            Using picture As Image = New clsNumberObject(Me.objectParameter.fixedPicturePosition.X,
                                                         Me.objectParameter.fixedPicturePosition.Y,
                                                         Me.objectParameter.fixedPictureSize,
                                                         movementAmount,
                                                         clsObjectParameter.maxAlpha,
                                                         False).getNumberPicture
                Me.backgroundGraphics.DrawImage(Me.backgroundBitmapLast, 0, 0, Me.PictureBox1.Width, Me.PictureBox1.Height)
                Me.backgroundGraphics.DrawImage(picture, New Rectangle(New Point, picture.Size), 0, 0, picture.Width, picture.Height, GraphicsUnit.Pixel)
            End Using
            Me.copyBitmapLast()
        Next
    End Sub

    Private Sub drawStringFieldObject()
        '文字描画
        Dim fontName As String = "HGGyoshotai"
        Me.backgroundGraphics.DrawImage(Me.backgroundBitmapLast, 0, 0, Me.PictureBox1.Width, Me.PictureBox1.Height)
        'MEMO: 何か右下に文字を表示したい場合は、ココで印字する文字を指定する
        'Me.backgroundGraphics.DrawString("", New Font(fontName, 20 * Me.objectParameter.minRatio), Brushes.Black, 560 * Me.objectParameter.minRatio, 310 * Me.objectParameter.minRatio)
        'Me.backgroundGraphics.DrawString("", New Font(fontName, 15 * Me.objectParameter.minRatio), Brushes.Black, 700 * Me.objectParameter.minRatio, 315 * Me.objectParameter.minRatio)
        'Me.backgroundGraphics.DrawString("", New Font(fontName, 27 * Me.objectParameter.minRatio, FontStyle.Bold), Brushes.Black, 580 * Me.objectParameter.minRatio, 345 * Me.objectParameter.minRatio)
        Me.copyBitmapLast()
    End Sub

    Private Sub readBingoLog()
        For Each logNumber As Integer In cBingoLog.pBingoList
            numberList.deleteNumber(logNumber)
            Me.cBingoLog.writeLog(logNumber)
            Me.drawGameInformation()
            Me.objectParameter.calcObjectNumberStringParameter(logNumber)
            Me.drawNumberAndHistoryObject3(logNumber)
        Next
    End Sub
#End Region
End Class



